The correction factors for the UNICADO turbo-engine library are based on a correlation of a coefficient by a spline fit. These coefficients have been adapted to a regression model. The old correlation is shown below:

// James from zunzun.com: "To the best of my knowledge this code is correct.
// If you find any errors or problems please contact
// me at zunzun@zunzun.com. the code below was partially based on the fortran code at:
// http://svn.scipy.org/svn/scipy/trunk/scipy/interpolate/fitpack/fpbisp.f
// http://svn.scipy.org/svn/scipy/trunk/scipy/interpolate/fitpack/fpbspl.f"
// TODO(Oli): understand, adapt, renew
double Engine::bSplineFit(const double& var_1,
                          const double& var_2,
                          const double tx[],
                          const double ty[],
                          const double coeff[]) {
    int nx = 6;
    int ny = 6;
    int kx = 2;
    int ky = 2;
    double h[] = {0.0, 0.0, 0.0, 0.0, 0.0,
                  0.0, 0.0, 0.0, 0.0, 0.0,
                  0.0, 0.0, 0.0, 0.0, 0.0,
                  0.0, 0.0, 0.0, 0.0, 0.0,
                  0.0, 0.0, 0.0, 0.0, 0.0};
    double hh[] = {0.0, 0.0, 0.0, 0.0, 0.0,
                   0.0, 0.0, 0.0, 0.0, 0.0,
                   0.0, 0.0, 0.0, 0.0, 0.0,
                   0.0, 0.0, 0.0, 0.0, 0.0,
                   0.0, 0.0, 0.0, 0.0, 0.0};
    double w_x[] = {0.0, 0.0, 0.0, 0.0, 0.0,
                    0.0, 0.0, 0.0, 0.0, 0.0,
                    0.0, 0.0, 0.0, 0.0, 0.0,
                    0.0, 0.0, 0.0, 0.0, 0.0,
                    0.0, 0.0, 0.0, 0.0, 0.0};
    double w_y[] = {0.0, 0.0, 0.0, 0.0, 0.0,
                    0.0, 0.0, 0.0, 0.0, 0.0,
                    0.0, 0.0, 0.0, 0.0, 0.0,
                    0.0, 0.0, 0.0, 0.0, 0.0,
                    0.0, 0.0, 0.0, 0.0, 0.0};
    int i, j, li, lj, lx, ky1, nky1, ly, i1, j1;
    double f, temp;
    int kx1 = kx + 1;
    int nkx1 = nx - kx1;
    int l = kx1;
    int l1 = l + 1;
    while ((var_1 >= tx[l1 - 1]) && (l != nkx1)) {
        l = l1;
        l1 = l + 1;
    }
    h[0] = 1.0;
    for (j = 1; j < kx + 1; j++) {
        for (i = 0; i < j; i++) {
            hh[i] = h[i];
        }
        h[0] = 0.0;
        for (i = 0; i < j; i++) {
            li = l + i;
            lj = li - j;
            if (tx[li] != tx[lj]) {
                f = hh[i] / (tx[li] - tx[lj]);
                h[i] = h[i] + f * (tx[li] - var_1);
                h[i + 1] = f * (var_1 - tx[lj]);
            } else {
                h[i + 1 - 1] = 0.0;
            }
        }
    }
    lx = l - kx1;
    for (j = 0; j < kx1; j++) {
        w_x[j] = h[j];
    }
    ky1 = ky + 1;
    nky1 = ny - ky1;
    l = ky1;
    l1 = l + 1;
    while ((var_2 >= ty[l1 - 1]) && (l != nky1)) {
        l = l1;
        l1 = l + 1;
    }
    h[0] = 1.0;
    for (j = 1; j < ky + 1; j++) {
        for (i = 0; i < j; i++) {
            hh[i] = h[i];
        }
        h[0] = 0.0;
        for (i = 0; i < j; i++) {
            li = l + i;
            lj = li - j;
            if (ty[li] != ty[lj]) {
                f = hh[i] / (ty[li] - ty[lj]);
                h[i] = h[i] + f * (ty[li] - var_2);
                h[i + 1] = f * (var_2 - ty[lj]);
            } else {
                h[i + 1 - 1] = 0.0;
            }
        }
    }
    ly = l - ky1;
    for (j = 0; j < ky1; j++) {
        w_y[j] = h[j];
    }
    l = lx * nky1;
    for (i1 = 0; i1 < kx1; i1++) {
        h[i1] = w_x[i1];
    }
    l1 = l + ly;
    temp = 0.0;
    for (i1 = 0; i1 < kx1; i1++) {
        int l2 = l1;
        for (j1 = 0; j1 < ky1; j1++) {
            l2 = l2 + 1;
            temp = temp + coeff[l2 - 1] * h[i1] * w_y[j1];
        }
        l1 = l1 + nky1;
    }
    return temp;
}


// TODO(Tobi/Oli): Check if we can find answers in the thesis.
// Correction for shaft power offtake
double Engine::correctionNPshaft(const double& Mach, const double& relCorrectedThrust) {
    double tx[] = {0.0000000000000000E+00, 0.0000000000000000E+00, 0.0000000000000000E+00,
                   9.4999999999999996E-01, 9.4999999999999996E-01, 9.4999999999999996E-01};
    double ty[] = {2.0000000000000001E-01, 2.0000000000000001E-01, 2.0000000000000001E-01,
                   1.0000000000000000E+00, 1.0000000000000000E+00, 1.0000000000000000E+00};
    double coeff[] = {-1.3607671534322846E-05, 1.1138342599257901E-04, 1.2331475498515764E-04,
                       6.6007903468491059E-04, 5.6818162267779817E-05, 1.1789620178416761E-05,
                       5.3132427593506474E-04, 9.2543175844155644E-06, 9.3053509883116934E-05};
    return this->bSplineFit(Mach, relCorrectedThrust, tx, ty, coeff);
}

// Fuel correction
double Engine::correctionFuelPshaft(const double& Mach, const double& relCorrectedThrust) {
    double tx[] = {0.0000000000000000E+00, 0.0000000000000000E+00, 0.0000000000000000E+00,
                   9.4999999999999996E-01, 9.4999999999999996E-01, 9.4999999999999996E-01};
    double ty[] = {2.0000000000000001E-01, 2.0000000000000001E-01, 2.0000000000000001E-01,
                   1.0000000000000000E+00, 1.0000000000000000E+00, 1.0000000000000000E+00};
    double coeff[] = {-2.5837834237421149E-02, -1.0711434673469290E-03, -2.5439175826159569E-03,
                      -1.0069640902594311E-02, 1.5266620197959149E-03, -1.7904074229127946E-04,
                      -8.2006349300742121E-03, -1.3883874951020421E-03, -1.0450412066975881E-03};
    return this->bSplineFit(Mach, relCorrectedThrust, tx, ty, coeff);
}

// Temperature Correction
double Engine::correctionTemperaturePshaft(const double& Mach, const double& relCorrectedThrust) {
    double tx[] = {0.0000000000000000E+00, 0.0000000000000000E+00, 0.0000000000000000E+00,
                   9.4999999999999996E-01, 9.4999999999999996E-01, 9.4999999999999996E-01};
    double ty[] = {2.0000000000000001E-01, 2.0000000000000001E-01, 2.0000000000000001E-01,
                   1.0000000000000000E+00, 1.0000000000000000E+00, 1.0000000000000000E+00};
    double coeff[] = {2.0179844142840443E-02, 9.9998095350463238E-04, 1.0530892286586279E-03,
                      7.7945291521994472E-03, -1.9413931634641257E-03, -5.5794839450185583E-04,
                      6.1954327010853441E-03, 1.4410673050556570E-03, 3.1225774576066793E-04};
    return this->bSplineFit(Mach, relCorrectedThrust, tx, ty, coeff);
}

// Correction for bleed air
// Correction for spool speed
double Engine::correctionNBleed(const double& Mach, const double& relCorrectedThrust) {
    double tx[] = {0.0000000000000000E+00, 0.0000000000000000E+00, 0.0000000000000000E+00,
                   9.4999999999999996E-01, 9.4999999999999996E-01, 9.4999999999999996E-01};
    double ty[] = {2.0000000000000001E-01, 2.0000000000000001E-01, 2.0000000000000001E-01,
                   1.0000000000000000E+00, 1.0000000000000000E+00, 1.0000000000000000E+00};
    double coeff[] = {-2.2879929300241190E-02, -2.5645068822393251E-02, -7.4105528066994442E-02,
                      -6.1484344169749523E-02, -3.0319084774474380E-02, -2.3261216155606987E-01,
                      -8.2587971169220759E-02, -7.1881591301168807E-02, -1.2079008354740260E-01};
    return this->bSplineFit(Mach, relCorrectedThrust, tx, ty, coeff);
}

// Correction for fuel flow
double Engine::correctionFuelBleed(const double& Mach, const double& relCorrectedThrust) {
  double tx[] = {0.0000000000000000E+00, 0.0000000000000000E+00, 0.0000000000000000E+00,
                 9.4999999999999996E-01, 9.4999999999999996E-01, 9.4999999999999996E-01};
  double ty[] = {2.0000000000000001E-01, 2.0000000000000001E-01, 2.0000000000000001E-01,
                 1.0000000000000000E+00, 1.0000000000000000E+00, 1.0000000000000000E+00};
  double coeff[] = {-1.9244467913771426E+00, -1.6755239222087011E+00, -1.6626660180012969E+00,
                    -1.9676515646334021E+00, -1.5206763095085662E+00, -1.7518209503286839E+00,
                  -2.2785766333951023E+00, -1.6779305236433939E+00, -1.8629590437506882E+00};
  return this->bSplineFit(Mach, relCorrectedThrust, tx, ty, coeff);

// Temperature correction
double Engine::correctionTemperatureBleed(const double& Mach, const double& relCorrectedThrust) {
    double tx[] = {0.0000000000000000E+00, 0.0000000000000000E+00, 0.0000000000000000E+00,
                   9.4999999999999996E-01, 9.4999999999999996E-01, 9.4999999999999996E-01};
    double ty[] = {2.0000000000000001E-01, 2.0000000000000001E-01, 2.0000000000000001E-01,
                   1.0000000000000000E+00, 1.0000000000000000E+00, 1.0000000000000000E+00};
    double coeff[] = {1.3087839612344523E+00, 1.1789395870030082E+00, 1.3342904865578280E+00,
                      1.3262217664829725E+00, 1.1629301049563476E+00, 1.4896135349308934E+00,
                      1.2561877270144526E+00, 1.1735511306315773E+00, 1.3949702703206868E+00};
    return this->bSplineFit(Mach, relCorrectedThrust, tx, ty, coeff);
}
