# Introduction {#mainpage}
The library _engine_ is the core analysis library for engine data in UNICADO. The engine library is used to get the engine data in the operating point. This engine data depends, next to the operating point, on the scale factor and other offtakes from the engine. The overall goal is to easily access this data from this single source of truth.

Within the propulsionDesign module, the engines for the aircraft are chosen and the specific files are copied to the engine directory. Additionally, the _scale factor_ is calculated in propulsion design. This scale factor specifies the factor with which the engines' thrust is scaled to match the aircraft requirements (see documentation propulsionDesign). 

The application of the scale factor to the engine data is made through the engine library. The engine library provides functions to get aircraft parameters without having to further manipulate the data according to the scale factor or other factors influencing the performance of the engine.

The engine data is available as a engine.xml dataset as well as different csv files for values that are dependent on the mach number, altitude and engine power setting. This data is raw data and is not scaled by the propulsionDesign or any other module. In propulsionDesign the only part of the data that is modified is the fuelflow csv file with respect to the efficiency gains specified by the user. This library is responsible for the readout of the engine data, the scaling and the manipulation of the values due to factors influencing the performance.

Within the engine library the following factors can be applied by choice or are applied within the functions by default to calculate the engine performance:
- The scale factor of the engine calculated by the propulsionDesign module.
- Temperature which is different to the ISA standard conditions.
- The derating of the engine.
- Bleed air extraction of the turbofan engine.
- Spool shaft offtake of the turbofan engine.

The engine data is divided into two parts. The engine.xml datafile includes data that is not dependent on the operating point. The operating point is the combination of the mach number, the altitude and the power setting of the engine. In turbofan aircraft, the powersetting is the value for the rotational speed of the low pressure spool (N1).

Depending on where the data is stored, the engine lib either uses the engine.xml or the specific csv file to get the data. For the csv file, the operating point must be specified. For the calculation of the required value a linear interpolation is made in between different existing operating points.